//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  clrLimeGreen
#property indicator_color2  clrOrange
#property indicator_color3  clrSilver
#property indicator_color4  clrSilver

//
//
//
//
//

enum enColorTypes
{
   cltZeroCross, // Color change on zero cross
   cltLevelCross // Color change on outer levels cross
};
extern ENUM_TIMEFRAMES    TimeFrame    = PERIOD_CURRENT;
extern int                MomPeriod    =  14;
extern ENUM_APPLIED_PRICE MomPrice     = PRICE_CLOSE;
extern int                MinMaxPeriod = 100;
extern double             LevelUp      =  80;
extern double             LevelDown    =  20;
extern enColorTypes       ColorChangeWhen = cltZeroCross;

//
//
//
//
//

double momMin[];
double momMax[];
double momLUp[];
double momLMi[];
double momLDn[];
double mom[];
double momUa[];
double momUb[];
double momDa[];
double momDb[];
double colors[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(11);
   SetIndexBuffer(0,momUa); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,momUb); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,momDa); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,momDb); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,mom);
   SetIndexBuffer(5,momLUp);
   SetIndexBuffer(6,momLMi);
   SetIndexBuffer(7,momLDn);
   SetIndexBuffer(8,momMin);
   SetIndexBuffer(9,momMax);
   SetIndexBuffer(10,colors);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
   
      IndicatorShortName(timeFrameToString(TimeFrame)+" velocity fl ("+MomPeriod+","+DoubleToStr(LevelDown,2)+","+DoubleToStr(LevelUp,2)+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { momUa[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      for(i=limit; i>=0; i--) 
      {
         mom[i]    = iMomentumS(iMA(NULL,0,1,0,MODE_SMA,MomPrice,i),MomPeriod,1,2,i);
         momMin[i] = mom[ArrayMinimum(mom,MinMaxPeriod,i)];
         momMax[i] = mom[ArrayMaximum(mom,MinMaxPeriod,i)];
         momDa[i]  = EMPTY_VALUE;
         momDb[i]  = EMPTY_VALUE;
         momUa[i]  = EMPTY_VALUE;
         momUb[i]  = EMPTY_VALUE;
            double range = momMax[i]-momMin[i];
               momLDn[i] = momMin[i]+range*LevelDown/100.0;
               momLMi[i] = momMin[i]+range*0.5;
               momLUp[i] = momMin[i]+range*LevelUp/100.0;
               colors[i] = colors[i+1];
               if (ColorChangeWhen==cltZeroCross)
               {
                  if (mom[i]>momLMi[i]) colors[i] =  1;
                  if (mom[i]<momLMi[i]) colors[i] = -1;
               }
               else
               {
                  colors[i] = 0;
                  if (mom[i]>momLUp[i]) colors[i] =  1;
                  if (mom[i]<momLDn[i]) colors[i] = -1;
               }
               if (colors[i] ==  1) { momUa[i] = High[i]; momUb[i] = Low[i]; };
               if (colors[i] == -1) { momUb[i] = High[i]; momUa[i] = Low[i]; };
               if (colors[i] ==  0) { momDa[i] = High[i]; momDb[i] = Low[i]; };
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         colors[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,MinMaxPeriod,LevelUp,LevelDown,ColorChangeWhen,10,y);
         momDa[i]  = EMPTY_VALUE;
         momDb[i]  = EMPTY_VALUE;
         momUa[i]  = EMPTY_VALUE;
         momUb[i]  = EMPTY_VALUE;
               if (colors[i] ==  1) { momUa[i] = High[i]; momUb[i] = Low[i]; };
               if (colors[i] ==  1) { momUb[i] = High[i]; momUa[i] = Low[i]; };
               if (colors[i] ==  0) { momDa[i] = High[i]; momDb[i] = Low[i]; };
   }
   return(0);
         
}

//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workMom[];
double iMomentumS(double price, double length, double powSlow, double powFast, int i)
{
   if (ArraySize(workMom)!=Bars) ArrayResize(workMom,Bars);
      i = Bars-i-1; workMom[i] = price;
      
      //
      //
      //
      //
      //
      
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;
         for(int k=0; k<length; k++)
         {
            double weight = length-k;
               suma  += workMom[i-k] * MathPow(weight,powSlow);
               sumb  += workMom[i-k] * MathPow(weight,powFast);
               sumwa += MathPow(weight,powSlow);
               sumwb += MathPow(weight,powFast);
         }
   return(sumb/sumwb-suma/sumwa);
}  


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}